
! +  ==========
! +--MARphy.inc
! +  ==========

      character*1     labnum
      common /labgen/ labnum(0:10)
! +...                labnum: Alphanumeric Character

      integer         izr,iun
      common /numint/ izr,iun
! +...                izr = 0     
! +                       iun = 1     
      real                zero,demi,unun,epsi,eps9,eps12,third,thous
      real                argmin,argmax
      common /numrea/     zero,demi,unun,epsi,eps9,eps12,third,thous
! +...                    zero = 0.0e+0
! +                            demi = 0.5e+0
! +                                 unun = 1.0e+0
! +                                      epsi = 1.0e-6
! +                                           eps9 = 1.0e-9
! +                                                eps12= 1.0e-12
! +                                                      third=1/3
! +                                                            thous=1.e3
      common /numrea2/    argmin,argmax
! +                       argmin:        Function exp(x) Minimum Argument
! +                              argmax: Function exp(x) Maximum Argument
! +                                      (Min/Max are Machine Dependant)

      real            pi,degrad,hourad
      common /phyphy/ pi,degrad,hourad
! +...                pi    = 3.141592653589793238462643e0
! +                   degrad= pi / 180.d0
! +                   hourad= pi /  12.d0

      real            earthr,earthv,gravit,gravi2,grvinv
      common /phygeo/ earthr,earthv,gravit,gravi2,grvinv
! +...                earthr: Earth Radius                  =6371.d+3    m     
! +...                earthv: Earth Angular Velocity        = 7.29d-5  s-1
! +                   gravit: Earth Gravity Acceleration    = 9.81    m/s2
! +                   gravi2: idem (squared) 
! +                   grvinv: idem (inverse) 

      real            akmol, vonkar, A_Turb, AhTurb, AsTurb, r_Turb
      common /phytur/ akmol, vonkar, A_Turb, AhTurb, AsTurb, r_Turb
! +...                akmol : Air Viscosity                 = 1.35d-5 m2/s
! +                   vonkar: von Karman constant           = 0.4
! +                   A_Turb: Stability  Coefficient Moment = 5.8
! +                   AhTurb: Stability  Coefficient Heat   = 5.4
! +                   AsTurb: Stability  Coefficient BLOW * = 4.0
! +                   r_Turb: Turbulent Diffusivities Ratio K*/Km

      real            RDryAi,ra,cp,CvDrya,racv,cap,pcap,stefan,qv_MIN
      real            RVapor,epsq,Lv_H2O,Ls_H2O,r_LvCp,r_LcCp,r_LsCp
      common /phyatm/ RDryAi,ra,cp,CvDrya,racv,cap,pcap,stefan,qv_MIN
      common/phyatm2/ RVapor,epsq,Lv_H2O,Ls_H2O,r_LvCp,r_LcCp,r_LsCp
! +...                RDryAi: perfect gas law constant for dry air (287 J/kg/K)
! +                   ra    : perfect gas law constant for dry air (287 J/kg/K)
! +                   cp    : dry air specific heat at constant p (1004 J/kg/K)
! +                   CvDryA: dry air specific heat at constant V ( 717 J/kg/K)
! +                   racv  = ra / cv      = ra /(cp-ra)
! +                   cap   = ra / cp
! +                   pcap  = 100.[kPa]**cap 
! +...                RVapor: perfect gas law constant Water Vapor (461 J/kg/K)
! +                   epsq  : Minimum Water Vapor Content    =    3.00d-6 kg/kg  
! +                   Lv_H2O: Latent Heat Vaporisation/Water = 2500.00d+3 J/kg
! +                   Ls_H2O: Latent Heat Sublimation /Ice   = 2833.60d+3 J/kg
! +                   r_LvCp [Lv=2500000J/kg]/[Cp=1004J/kg/K]= 2490.04    K/[kg/kg]
! +                   r_LvCp [Lc= 333600J/kg]/[Cp=1004J/kg/K]=  332.27    K/[kg/kg]
! +                   r_LvCp [Ls=2833600J/kg]/[Cp=1004J/kg/K]= 2822.31    K/[kg/kg]
! +                   stefan: Stefan Constant                =    5.67d-8 W/m2/K4
! +                   qv_MIN: Minimum Specific Humidity      =    3.00d-6 kg/kg

      real            tfrwat,siclf,cdsice,hic0,ro_Wat,C__Wat,fracoh
      common /physea/ tfrwat,siclf,cdsice,hic0,ro_Wat,C__Wat,fracoh
! +...                tfrwat: Sea-Water freezing Temperature =  271.20d+0 K
! +                   siclf : Sea-Ice Heat of Fusion         =  302.00d+6 J/m3
! +                   cdsice: Sea-Ice Thermal Conductivity   =    2.04d+0 W/mK
! +                   hic0  : Sea-Ice Initial Thickness      =    2.00d+0 m
! +                   ro_Wat: Density       of Water         = 1000.00d+0 kg/m3
! +                   C__Wat: Heat Capacity of Water         = 4186.00d+0 J/kg/K
! +                   fracoh: 25% of cooling = Oceanic Heat Flux 
! +***                        (Hibler 1984)    (ANTARCTIC Ocean)

      real            ro_Ice,cdice
      common /phyice/ ro_Ice,cdice
! +...                ro_Ice:  Density      of Pure Ice       =  920.00d+0 kg/m3
! +                   cdice :  Conductivity of Pure Ice       =    2.51d+0 W/m/K

      real            TfSnow,csnow,r0sno,frsno,Lf_H2O
      common /physno/ TfSnow,csnow,r0sno,frsno,Lf_H2O
! +...                TfSnow:        Snow melting Temperature=  273.15d+0 K
! +                    csnow:Heat Capacity of Snow             2105      J/kg/K
! +                         (Loth et al. 1993, JGR 98 D6, 2.2.2 2e para p.10453)
! +                   r0sno : Fresh  Snow Density                50.00d+0 kg/m3
! +                   frsno : Fresh blowed Snow Density         300.00d+0 kg/m3
! +                   Lf_H2O: Latent Heat of Fusion of Snow  =    3.34d+5 J/kg
      real  EmiSnoao,EmiWatao ! Emissivity of a sea Snow/ice from NEMO !CK coupling AO EmiSnoao= 0.95) ! Emissivity of a Water Area from NEMO !CK coupling AO EmiWatao= 1.
      common/emiao/emisnoao,emiwatao
